diff -uwr sourceold/scripts/engine_game.cpp source/scripts/engine_game.cpp
--- sourceold/scripts/engine_game.cpp	2011-10-22 19:44:00.545898400 +0800
+++ source/scripts/engine_game.cpp	2012-05-23 10:47:48.822265600 +0800
@@ -24,6 +24,7 @@
 #include "VehicleFactoryGameObj.h"
 #include "VehicleFactoryGameObjDef.h"
 #include "HarvesterClass.h"
+#include "DefinitionMgrClass.h"
 REF_DEF2(CombatManager::IAmServer, bool, 0x00855EC8, 0x008550B0);
 RENEGADE_FUNCTION
 void *Game_Mode_Find(const char *)
@@ -48,7 +49,7 @@
 VehicleGameObj *BaseControllerClass::Get_Harvester_Vehicle()
 {
 	BuildingGameObj* refinery = Find_Building(BuildingConstants::TYPE_REFINERY);
-	return refinery ? refinery->As_RefineryGameObj()->Get_Harvester_Vehicle() : nullptr;
+	return refinery && refinery->As_RefineryGameObj() ? refinery->As_RefineryGameObj()->Get_Harvester_Vehicle() : nullptr;
 }
 void BaseControllerClass::Set_Can_Generate_Soldiers(bool CanGenerate)
 {
@@ -201,12 +202,11 @@
 
 bool SCRIPTS_API Is_Harvester(GameObject *obj)
 {
-	if (!As_VehicleGameObj(obj))
+	if (!obj)
 	{
 		return false;
 	}
-	int ID = Commands->Get_ID(obj);
-	if (Commands->Get_ID(Find_Harvester(0)) == ID || Commands->Get_ID(Find_Harvester(1)) == ID)
+	if (Find_Harvester(0) == obj || Find_Harvester(1) == obj)
 	{
 		return true;
 	}
@@ -225,26 +225,26 @@
 
 int SCRIPTS_API Building_Type(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	GameObject *o = As_BuildingGameObj(obj);
+	BuildingGameObj *o = obj->As_BuildingGameObj();
 	if (!o)
 	{
 		return 0;
 	}
-	BuildingGameObjDef *d = (BuildingGameObjDef *)Get_Definition(obj);
-	return d->Get_Type();
+	const BuildingGameObjDef &d = o->Get_Definition();
+	return d.Get_Type();
 }
 
 bool SCRIPTS_API Is_Building_Dead(GameObject *obj)
 {
-	if (!obj || !Commands->Get_ID(obj))
+	if (!obj)
 	{
 		return 0;
 	}
-	BuildingGameObj *o = (BuildingGameObj *)As_BuildingGameObj(obj);
+	BuildingGameObj *o = obj->As_BuildingGameObj();
 	if (!o)
 	{
 		return 0;
@@ -252,7 +252,7 @@
 	return o->Is_Destroyed();
 }
 
-GameObject SCRIPTS_API *Find_Building(int team,int type)
+GameObject SCRIPTS_API *Find_Building_By_Type(int team,int type)
 {
 	BaseControllerClass *c = BaseControllerClass::Find_Base(team);
 	if (c)
@@ -285,13 +285,17 @@
 		return 0;
 	}
 	GameObject *obj = (GameObject *)d->Create();
-	if (As_BuildingGameObj(obj))
+	
+	if (obj)
+	{
+		BuildingGameObj *c = obj->As_BuildingGameObj();
+		if (c)
 	{
-		BuildingGameObj *c = (BuildingGameObj *)obj;
 		c->Set_Position(Position);
 		c->Collect_Building_Components();
 		c->Start_Observers();
-		return obj;
+			return c;
+		}
 	}
 	return 0;
 }
@@ -322,7 +326,7 @@
 	GameObject *o = 0;
 	if (c)
 	{
-		o = (GameObject *)c->Get_Harvester_Vehicle();
+		o = c->Get_Harvester_Vehicle();
 	}
 	return o;
 }
@@ -347,22 +351,10 @@
 	return false;
 }
 
-bool SCRIPTS_API Can_Generate_Soliders(int team)
-{
-	BaseControllerClass *c = BaseControllerClass::Find_Base(team);
-	if (c)
+bool SCRIPTS_API Can_Generate_Soldiers(int team)
 	{
+	if ( BaseControllerClass *c = BaseControllerClass::Find_Base(team) )
 		return c->Can_Generate_Soldiers();
-	}
-	return false;
-}
-
-bool SCRIPTS_API Is_A_Building(GameObject *obj)
-{
-	if (As_BuildingGameObj(obj))
-	{
-		return true;
-	}
 	return false;
 }
 
@@ -372,7 +364,7 @@
 	int Count = 0;
 	while (x)
 	{
-		GameObject *o = As_BuildingGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o && Commands->Get_Health(o) > 0 && (Get_Object_Type(o) == Team || Team == 2))
 		{
 			Count++;
@@ -387,10 +379,10 @@
 	SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_BuildingGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
-			const DefinitionClass *d = Get_Definition(o);
+			const DefinitionClass *d = &o->Get_Definition();
 			if (d->Get_Class_ID() == Class_ID)
 			{
 				if ((Get_Object_Type(o) == Team) || (Team == 2))
@@ -406,47 +398,62 @@
 
 GameObject SCRIPTS_API *Find_Power_Plant(int Team)
 {
-	return Find_Building(Team,BuildingConstants::TYPE_POWER_PLANT);
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_POWER_PLANT);
 }
 
 GameObject SCRIPTS_API *Find_Construction_Yard(int Team)
 {
-	return Find_Building(Team,BuildingConstants::TYPE_CONYARD);
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_CONYARD);
 }
 
 GameObject SCRIPTS_API *Find_Refinery(int Team)
 {
-	return Find_Building(Team,BuildingConstants::TYPE_REFINERY);
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_REFINERY);
 }
 
 GameObject SCRIPTS_API *Find_Repair_Bay(int Team)
 {
-	return Find_Building(Team,BuildingConstants::TYPE_REPAIR_BAY);
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_REPAIR_BAY);
 }
 
 GameObject SCRIPTS_API *Find_Soldier_Factory(int Team)
 {
-	return Find_Building(Team,BuildingConstants::TYPE_SOLDIER_FACTORY);
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_SOLDIER_FACTORY);
 }
 
-GameObject SCRIPTS_API *Find_Airstrip(int Team)
+GameObject SCRIPTS_API *Find_Vehicle_Factory(int Team)
 {
-	return Find_Building_By_Class_ID(Team,0xD006);
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_VEHICLE_FACTORY);
 }
 
-GameObject SCRIPTS_API *Find_War_Factory(int Team)
+GameObject SCRIPTS_API *Find_Shrine(int Team)
 {
-	return Find_Building_By_Class_ID(Team,0xD007);
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_SHRINE);
 }
 
-GameObject SCRIPTS_API *Find_Vehicle_Factory(int Team)
+GameObject SCRIPTS_API *Find_Helipad(int Team)
+{
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_HELIPAD);
+}
+
+GameObject SCRIPTS_API *Find_Tech_Center(int Team)
 {
-	return Find_Building(Team,BuildingConstants::TYPE_VEHICLE_FACTORY);
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_TECH_CENTER);
+}
+
+GameObject SCRIPTS_API *Find_Naval_Factory(int Team)
+{
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_NAVAL_FACTORY);
+}
+
+GameObject SCRIPTS_API *Find_Special(int Team)
+{
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_SPECIAL);
 }
 
 GameObject SCRIPTS_API *Find_Com_Center(int Team)
 {
-	return Find_Building(Team,BuildingConstants::TYPE_COM_CENTER);
+	return Find_Building_By_Type(Team,BuildingConstants::TYPE_COM_CENTER);
 }
 
 GameObject SCRIPTS_API *Find_Building_By_Team(int Team)
@@ -454,7 +461,7 @@
 	SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_BuildingGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
 			if (Get_Object_Type(o) == Team)
@@ -467,15 +474,15 @@
 	return 0;
 }
 
-GameObject SCRIPTS_API *Find_Building_By_Name(int Team,const char *Preset_Name)
+GameObject SCRIPTS_API *Find_Building_By_Preset(int Team,const char *Preset_Name)
 {
 	SLNode<BuildingGameObj> *x = GameObjManager::BuildingGameObjList.Head();
 	while (x)
 	{
-		GameObject *o = As_BuildingGameObj(x->Data());
+		GameObject *o = x->Data();
 		if (o)
 		{
-			const DefinitionClass *d = Get_Definition(o);
+			const DefinitionClass *d = &o->Get_Definition();
 			if (!_stricmp(d->Get_Name(),Preset_Name))
 			{
 				if ((Get_Object_Type(o) == Team) || (Team == 2))
@@ -502,10 +509,10 @@
 	BaseControllerClass* base = BaseControllerClass::Find_Base(Get_Object_Type(building));
 	if (base) 
 	{
-		if (Is_SoldierFactory(building))
+		if (building->As_SoldierFactoryGameObj())
 			base->Set_Can_Generate_Soldiers(true);
 		
-		if (Is_VehicleFactory(building))
+		if (building->As_VehicleFactoryGameObj())
 			base->Set_Can_Generate_Vehicles(true);
 		
 		base->Set_Object_Dirty_Bit(NetworkObjectClass::BIT_RARE, true);
@@ -581,12 +588,16 @@
 
 int SCRIPTS_API Get_Harvester_Preset_ID(int Team)
 {
-	RefineryGameObj *Ref = (RefineryGameObj*)Find_Refinery(Team);
-	if (!Ref)
+	if (!Find_Refinery(Team))
 	{
 		return 0;
 	}
-	return Ref->Get_Definition().Get_Harvester_ID();
+	BuildingGameObj *Ref = Find_Refinery(Team)->As_BuildingGameObj();
+	if (!Ref || !Ref->As_RefineryGameObj())
+	{
+		return 0;
+	}
+	return Ref->As_RefineryGameObj()->Get_Harvester_Def_ID();
 }
 
 bool SCRIPTS_API Is_Harvester_Preset(GameObject *obj)
@@ -603,3 +614,57 @@
 {
 	return (const SimpleGameObjDef &)BaseGameObj::Get_Definition();
 }
+
+bool SCRIPTS_API Vehicle_Preset_Is_Air(int preset)
+{
+	DefinitionClass *def = DefinitionMgrClass::Find_Definition(preset,true);
+	if (!def)
+	{
+		return false;
+	}
+	if (def->Get_Class_ID() == 12304)
+	{
+		VehicleGameObjDef *def2 = (VehicleGameObjDef *)def;
+		if (def2->Get_Type() == VEHICLE_TYPE_FLYING && !def2->Get_Build_At_Ground())
+		{
+			return true;
+		}
+	}
+	return false;
+}
+bool SCRIPTS_API Vehicle_Preset_Is_Naval(int preset)
+{
+	DefinitionClass *def = DefinitionMgrClass::Find_Definition(preset,true);
+	if (!def)
+	{
+		return false;
+	}
+	if (def->Get_Class_ID() == 12304)
+	{
+		VehicleGameObjDef *def2 = (VehicleGameObjDef *)def;
+		if (def2->Get_Type() == VEHICLE_TYPE_BOAT || def2->Get_Type() == VEHICLE_TYPE_SUB)
+		{
+			return true;
+		}
+	}
+	return false;
+}
+
+Vector3 SCRIPTS_API Get_Base_Center(int Team)
+{
+		Vector3 ReturnPos(0.0f,0.0f,0.0f);
+		BaseControllerClass *Base = BaseControllerClass::Find_Base(Team);
+		if (Base)
+		{
+				int Num = 0;
+				for (Num = 0;Num < Base->Get_Building_List().Count();Num++)
+				{
+						ReturnPos += Commands->Get_Position(Base->Get_Building_List()[Num]);
+				}
+				if (Num)
+				{
+						ReturnPos /= (float)Num;
+				}
+		}
+		return ReturnPos;
+}
diff -uwr sourceold/scripts/engine_game.h source/scripts/engine_game.h
--- sourceold/scripts/engine_game.h	2011-10-11 21:54:02.241210900 +0800
+++ source/scripts/engine_game.h	2012-05-23 10:47:49.340820300 +0800
@@ -13,48 +13,488 @@
 #define SCRIPTS_INCLUDE__ENGINE_GAME_H
 #include "GameData.h"
 
-void SCRIPTS_API Power_Base(int team,bool powered); //Power a base up or down, correctly handles the doubled build time and costs
-void SCRIPTS_API Set_Can_Generate_Soldiers(int team,bool cangenerate); //Sets if soliders are purchasable
-void SCRIPTS_API Set_Can_Generate_Vehicles(int team,bool cangenerate); //Sets if vehicles are purchaseable
-void SCRIPTS_API Destroy_Base(int team); //Destroys a base completly
-void SCRIPTS_API Beacon_Destroyed_Base(int team, bool destroyed); //Sets if a base was destroyed by a beacon in the beacon zone
-void SCRIPTS_API Enable_Base_Radar(int team, bool enable); //Enables radar for a base, same thing as the communications center does
-bool SCRIPTS_API Is_Harvester(GameObject *obj); //Is this object one of the 2 team AI harvesters?
-bool SCRIPTS_API Is_Radar_Enabled(int team); //returns if the radar is enabled
-int SCRIPTS_API Building_Type(GameObject *obj); //returns the type of a BuildingGameObj
-bool SCRIPTS_API Is_Building_Dead(GameObject *obj); //Does the game consider the building dead
-GameObject SCRIPTS_API *Find_Building(int team,int type); //Find a building by team and type
-GameObject SCRIPTS_API *Find_Base_Defense(int team); //Find base defense for a team
-bool SCRIPTS_API Is_Map_Flying(); //Is the current map a flying map
+/*!
+* Enable or disable base power for a team, this correctly handles all the relavent stuff including base defences and purchase time/cost changes.
+*
+* \param[in] team
+*   ID of the team to set power state for
+*
+* \param[in] powered
+*   whether to enable or disable power
+*
+*/
+void SCRIPTS_API Power_Base(int team,bool powered);
+
+/*!
+* Enable or disable advanced infantry purchasability for a team
+*
+* \param[in] team
+*   ID of the team to set advanced infantry purchasability for
+*
+* \param[in] cangenerate
+*   whether to enable or disable generation
+*
+*/
+void SCRIPTS_API Set_Can_Generate_Soldiers(int team,bool cangenerate);
+
+/*!
+* Enable or disable vehicle purchasability for a team
+*
+* \param[in] team
+*   ID of the team to set vehicle purchasability for
+*
+* \param[in] cangenerate
+*   whether to enable or disable generation
+*
+*/
+void SCRIPTS_API Set_Can_Generate_Vehicles(int team,bool cangenerate);
+
+/*!
+* Destroy the base of a team
+*
+* \param[in] team
+*   ID of the team to destroy the base of
+*
+*/
+void SCRIPTS_API Destroy_Base(int team);
+
+/*!
+* Set or clear the "beacon destroyed base" flag for a team
+*
+* \param[in] team
+*   ID of the team to change the "beacon destroyed base" flag on
+*
+* \param[in] destroyed
+*   whether to enable or disable the "beacon destroyed base" flag
+*
+*/
+void SCRIPTS_API Beacon_Destroyed_Base(int team, bool destroyed);
+
+/*!
+* Enable or disable radar for a team
+*
+* \param[in] team
+*   ID of the team to set radar for
+*
+* \param[in] enable
+*   whether to enable or disable radar
+*
+*/
+void SCRIPTS_API Enable_Base_Radar(int team, bool enable);
+
+/*!
+* Check if an object is an AI harvester
+*
+* \param[in] obj
+*   object to check
+*
+* \return
+*   True if the object is an AI harvester, false otherwise
+*/
+bool SCRIPTS_API Is_Harvester(GameObject *obj);
+
+/*!
+* Check if a teams base radar is enabled
+*
+* \param[in] team
+*   ID of the team to check the radar of
+*
+* \return
+*   True if the specified teams radar is enabled, false otherwise
+*/
+bool SCRIPTS_API Is_Radar_Enabled(int team);
+
+/*!
+* Get the building type for a building
+*
+* \param[in] obj
+*   object to get type of
+*
+* \return
+*   building type of the building
+*/
+int SCRIPTS_API Building_Type(GameObject *obj);
+
+/*!
+* Check if a building is dead
+*
+* \param[in] obj
+*   object to check
+*
+* \return
+*   True if the building is dead, false otherwise
+*/
+bool SCRIPTS_API Is_Building_Dead(GameObject *obj);
+
+/*!
+* Find the first building of a given building type for this team
+*
+* \param[in] team
+*   ID of the team to find the building for
+*
+* \param[in] type
+*   type to find
+*
+* \return
+*   First building for this team of this type (if any)
+*/
+GameObject SCRIPTS_API *Find_Building_By_Type(int team,int type);
+
+/*!
+* Find the first base defense building for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the base defense building for
+*
+* \return
+*   First base defense building for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Base_Defense(int team);
+
+/*!
+* Check if the current map is a flying map
+*
+* \return
+*   True if the map is a flying time map
+*/
+bool SCRIPTS_API Is_Map_Flying();
+
 GameObject SCRIPTS_API *Create_Building(const char *preset,const Vector3 & Position); //Create a building controller
-GameObject SCRIPTS_API *Find_Harvester(int team); //Find this teams current harvester, if any
-bool SCRIPTS_API Is_Base_Powered(int team); //Is this teams base powered
-bool SCRIPTS_API Can_Generate_Vehicles(int team); //Can this team buy vehicles
-bool SCRIPTS_API Can_Generate_Soliders(int team); //Can this team buy soldiers
-cGameData SCRIPTS_API *The_Game(); //get the cGameData
-cGameDataSkirmish SCRIPTS_API *The_Skirmish_Game(); //get the cGameDataSkirmish
-cGameDataCnc SCRIPTS_API *The_Cnc_Game(); //get the cGameDataCnc
-cGameDataSinglePlayer SCRIPTS_API *The_Single_Player_Game(); //get the cGameDataSinglePlayer
-bool SCRIPTS_API Is_A_Building(GameObject *obj); //is this object any building type
-int SCRIPTS_API Get_Building_Count_Team(int Team); //number of buildings a team has that are alive
-GameObject SCRIPTS_API *Find_Building_By_Team(int Team); //finds the first building of this team,0 = Nod,1 = GDI
-GameObject SCRIPTS_API *Find_Building_By_Name(int Team,const char *Preset_Name); //finds the first building of team where preset name matches name,0 = Nod,1 = GDI
-GameObject SCRIPTS_API *Find_Power_Plant(int Team); //finds the first powerplant for Team,0 = Nod,1 = GDI,2 = either
-GameObject SCRIPTS_API *Find_Construction_Yard(int Team); //finds the first construction yard for Team,0 = Nod,1 = GDI,2 = either
-GameObject SCRIPTS_API *Find_Refinery(int Team); //finds the first refinery for Team,0 = Nod,1 = GDI,2 = either
-GameObject SCRIPTS_API *Find_Repair_Bay(int Team); //finds the first repair bay for Team,0 = Nod,1 = GDI,2 = either
-GameObject SCRIPTS_API *Find_Soldier_Factory(int Team); //finds the first soldier factory for Team,0 = Nod,1 = GDI,2 = either
-GameObject SCRIPTS_API *Find_Airstrip(int Team); //finds the first airstrip for Team,0 = Nod,1 = GDI,2 = either
-GameObject SCRIPTS_API *Find_War_Factory(int Team); //finds the first war factory for Team,0 = Nod,1 = GDI,2 = either
-GameObject SCRIPTS_API *Find_Vehicle_Factory(int Team); //finds the first airstrip for Team,if none is found,finds the first war factory for Team,0 = Nod,1 = GDI,2 = either
-GameObject SCRIPTS_API *Find_Com_Center(int Team); //finds the first communications center for Team,0 = Nod,1 = GDI,2 = either
+
+/*!
+* Find the AI harvester for a team (if any)
+*
+* \param[in] team
+*   ID of the team to find the harvester for
+*
+* \return
+*   AI harvester object
+*/
+GameObject SCRIPTS_API *Find_Harvester(int team);
+
+/*!
+* Check if a teams base is powered
+*
+* \param[in] team
+*   ID of the team to check the base power of
+*
+* \return
+*   True if the specified teams base is powered, false otherwise
+*/
+bool SCRIPTS_API Is_Base_Powered(int team);
+
+/*!
+* Check if a team can currently purchase vehicles
+*
+* \param[in] team
+*   ID of the team to check vehicle purchasability for
+*
+* \return
+*   True if the specified team can purchase vehicles, false otherwise
+*/
+bool SCRIPTS_API Can_Generate_Vehicles(int team);
+
+/*!
+* Check if a team can currently purchase advanced infantry characters
+*
+* \param[in] team
+*   ID of the team to check advanced infantry purchasability for
+*
+* \return
+*   True if the specified team can purchase advanced infantry characters, false otherwise
+*/
+bool SCRIPTS_API Can_Generate_Soldiers(int team);
+
+/*!
+* Get the current cGameData
+*
+* \return
+*   current cGameData
+*/
+cGameData SCRIPTS_API *The_Game();
+
+/*!
+* Get the current cGameDataSkirmish, if any
+*
+* \return
+*   current cGameDataSirmish, if any
+*/
+cGameDataSkirmish SCRIPTS_API *The_Skirmish_Game();
+
+/*!
+* Get the current cGameDataCnc, if any
+*
+* \return
+*   current cGameDataCnc, if any
+*/
+cGameDataCnc SCRIPTS_API *The_Cnc_Game();
+
+/*!
+* Get the current cGameDataSinglePlayer, if any
+*
+* \return
+*   current cGameDataSinglePlayer, if any
+*/
+cGameDataSinglePlayer SCRIPTS_API *The_Single_Player_Game();
+
+/*!
+* Get the count of how many buildings a given team has
+*
+* \param[in] Team
+*   ID of the team to count the buildings of
+*
+* \return
+*   count of the buildings for that team
+*/
+int SCRIPTS_API Get_Building_Count_Team(int Team);
+
+/*!
+* Find the first building for this team
+*
+* \param[in] Team
+*   ID of the team to find the building for
+*
+* \return
+*   First building for this team
+*/
+GameObject SCRIPTS_API *Find_Building_By_Team(int Team);
+
+/*!
+* Find the first building of a given preset type for this team
+*
+* \param[in] Team
+*   ID of the team to find the building for
+*
+* \param[in] Preset_Name
+*   preset name to find
+*
+* \return
+*   First building for this team of this preset (if any)
+*/
+GameObject SCRIPTS_API *Find_Building_By_Preset(int Team,const char *Preset_Name);
+
+/*!
+* Find the first power plant for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the power plant for
+*
+* \return
+*   First power plant for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Power_Plant(int Team);
+
+/*!
+* Find the first construction yard for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the construction yard for
+*
+* \return
+*   First construction yard for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Construction_Yard(int Team);
+
+/*!
+* Find the first refinery for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the refinery for
+*
+* \return
+*   First refinery for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Refinery(int Team);
+
+/*!
+* Find the first repair bay for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the repair bay for
+*
+* \return
+*   First repair bay for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Repair_Bay(int Team);
+
+/*!
+* Find the first soldier factory for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the soldier factory for
+*
+* \return
+*   First soldier factory for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Soldier_Factory(int Team);
+
+/*!
+* Find the first vehicle factory for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the vehicle factory for
+*
+* \return
+*   First vehicle factory for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Vehicle_Factory(int Team);
+
+/*!
+* Find the first com center for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the com center for
+*
+* \return
+*   First com center for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Com_Center(int Team);
+
+/*!
+* Find the first special building for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the special building for
+*
+* \return
+*   First special building for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Special(int Team);
+
+/*!
+* Find the first naval factory for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the naval factory for
+*
+* \return
+*   First naval factory for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Naval_Factory(int Team);
+
+/*!
+* Find the first tech center for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the tech center for
+*
+* \return
+*   First tech center for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Tech_Center(int Team);
+
+/*!
+* Find the first helipad for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the helipad for
+*
+* \return
+*   First helipad for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Helipad(int Team);
+
+/*!
+* Find the first shrine for this team (if any)
+*
+* \param[in] Team
+*   ID of the team to find the shrine for
+*
+* \return
+*   First shrine for this team (if any)
+*/
+GameObject SCRIPTS_API *Find_Shrine(int Team);
+
 void SCRIPTS_API Restore_Building(GameObject* obj); //restores a building to life
-bool SCRIPTS_API Is_Gameplay_Permitted(); //is gameplay permitted
-bool SCRIPTS_API Is_Dedicated(); //returns false if game.exe, true if WFDS/LFDS
-unsigned int SCRIPTS_API Get_Current_Game_Mode(); //Get the current game mode, 0 = function error, 1 = single player, 2 = skirmish, 3 = WOL, 4 = GameSpy, 5 = LAN. May not always differentiate correctly between WOL, Gamespy and LAN, especially when running as a non-dedicated server.
+
+/*!
+* Check if gameplay is permitted
+*
+* \return
+*   True if gameplay is permitted
+*/
+bool SCRIPTS_API Is_Gameplay_Permitted();
+
+/*!
+* Check if running on the FDS
+*
+* \return
+*   True if running on the FDS
+*/
+bool SCRIPTS_API Is_Dedicated();
+
+/*!
+* Get current game mode, 0 = error, 1 = single player, 2 = skirmish, 3 = WOL, 4 = GameSpy, 5 = LAN.
+* May not always differentiate correctly between WOL, Gamespy and LAN, especially when running as a non-dedicated server.
+*
+* \return
+*   Current game mode
+*/
+unsigned int SCRIPTS_API Get_Current_Game_Mode();
+
 void SCRIPTS_API Get_Private_Message_Color(unsigned int *red, unsigned int *green, unsigned int *blue); //get color for private messages
 void SCRIPTS_API Get_Public_Message_Color(unsigned int *red, unsigned int *green, unsigned int *blue); //get color for public messages
-int SCRIPTS_API Get_Harvester_Preset_ID(int Team); //Get the harvester preset ID for this team
-bool SCRIPTS_API Is_Harvester_Preset(GameObject *obj); //Checks if the object has the same preset used for the harvesters
-bool SHADERS_API Is_Night_Map(); //is the current map a nighttime map
+
+/*!
+* Get the AI harvester preset ID of a specific team
+*
+* \param[in] team
+*   ID of the team to get the harvester preset ID of
+*
+* \return
+*   ID of the AI harvester preset for this team
+*/
+int SCRIPTS_API Get_Harvester_Preset_ID(int Team);
+
+/*!
+* Check if a preset matches the AI harvester preset set in the refinery
+*
+* \param[in] preset
+*   ID of the preset to check
+*
+* \return
+*   True if the preset matches the AI harvester preset set in the refinery
+*/
+bool SCRIPTS_API Is_Harvester_Preset(GameObject *obj);
+
+/*!
+* Check if the current map is a night time map
+*
+* \return
+*   True if the map is a night time map
+*/
+bool SHADERS_API Is_Night_Map();
+
+/*!
+* Check if a preset is an air unit
+*
+* \param[in] preset
+*   ID of the preset to check
+*
+* \return
+*   True if the preset is an air unit (i.e. will be built at the air factory when its built)
+*/
+bool SCRIPTS_API Vehicle_Preset_Is_Air(int preset);
+
+/*!
+* Check if a preset is a naval unit
+*
+* \param[in] preset
+*   ID of the preset to check
+*
+* \return
+*   True if the preset is a naval unit (i.e. will be built at the naval factory when its built)
+*/
+bool SCRIPTS_API Vehicle_Preset_Is_Naval(int preset);
+
+/*!
+* Find the center point of a base
+*
+* \param[in] team
+*   ID of the team to use
+*
+* \return
+*   Center of that teams base
+*/
+Vector3 SCRIPTS_API Get_Base_Center(int Team);
 #endif
